Subject: Re: powerpc: Remove arch/powerpc's dependence on asm-ppc/pg{alloc, table}.h

From: Christoph Hellwig <[email-masked]>
Date: Mon, 30 Apr 2007 11:18:46 +0200

On Mon, Apr 30, 2007 at 04:30:56PM +1000, David Gibson wrote:
> powerpc: Remove arch/powerpc's dependence on asm-ppc/pg{alloc,table}.h
> 
> Currently, all 32-bit powerpc platforms use asm-ppc/pgtable.h and
> asm-ppc/pgalloc.h, even when otherwise compiled with ARCH=powerpc.
> Those asm-ppc files are a fairly nasty tangle of #ifdefs including a
> bunch of things which shouldn't be necessary any more in arch/powerpc.
> 
> Cleaning up that mess is going to take a while, but this patch is a
> first step.  It separates the asm-powerpc/pg{alloc,table}.h into 64
> bit and 32 bit versions in asm-powerpc, which the basic .h files in
> asm-powerpc select based on config.  We make a few tiny tweaks to the
> innards of the files along the way, making the outermost ifdefs
> (double-inclusion protection and __KERNEL__) a little cleaner, and
> #including asm-generic/pgtable.h from the top-level
> asm-powerpc/pgtable.h (since both the old 32-bit and 64-bit versions
> ended with such an #include).

Nice cleanup.  Btw, you can just kill the __KERNEL__ completely,
neither pgalloc.h nor pgtable are exported to userspace (as in
part of header-y or unifdef-y in include/asm-powerpc/Kbuild)